KAccelGen Namespace Reference (kdeui Library)

| # kdeui Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KAccelGen Namespace Reference

Provides functions that, given a collection of QStrings, will automatically and intelligently assign menu accelerators to the QStrings in the collection. More...

## Classes
class | Deref
| Static dereference class, for use as a template parameter. More...
class | Deref_Key
| Static dereference class that calls the key() method on its target; for use as a template parameter. More...
## Functions
bool | isLegalAccelerator (const QString &str, uint index)
| Helper to determine if the given offset in the string could be a legal alphanumeric accelerator.
template<class Iter, class Deref> void | loadPredefined (Iter begin, Iter end, QMap< QChar, bool > &keys)
| Loads all legal predefined accelerators in the (implicitly specified) collection into the given QMap.
template<class Iter, class Iter_Deref> void | generate (Iter begin, Iter end, QStringList &target)
| Main, maximally flexible template function that assigns accelerators to the elements of a collection of QStrings.
template<class Iter> void | generateFromKeys (Iter begin, Iter end, QStringList &target)
| Another convenience function; looks up the key instead of dereferencing directly for the given iterator.
void | generate (const QStringList &source, QStringList &target)
| Convenience function; generates accelerators for all the items in a QStringList.
template<class Key> void | generateFromValues (const QMap< Key, QString > &source, QStringList &target)
| Convenience function; generates accelerators for all the values in a QMap<T,QString>.
template<class Data> void | generateFromKeys (const QMap< QString, Data > &source, QStringList &target)
| Convenience function; generates an accelerator mapping from all the keys in a QMap<QString,T>.

## Detailed Description

Provides functions that, given a collection of QStrings, will automatically and intelligently assign menu accelerators to the QStrings in the collection.

NOTE: When this file speaks of "accelerators", we really mean accelerators as defined by the KDE User Interface Guidelines. We do NOT mean "shortcuts", which are what's handled by most other KDE libraries with "accel" in the name.

In the Qt library, the mechanism for adding a keyboard accelerator to a menu item is to insert an '&' before the letter. Since we usually don't want to disturb the original collection, the idiom in these functions is to populate a "target" QStringList parameter with the input collectin's QStrings, plus possibly some added '&' characters.

That is the mechanism. Here is the policy, in order of decreasing importance (it may seem like these are implementation details, but IMHO the policy is an important part of the interface):

1. If the string already contains an '&' character, skip this string, because we consider such strings to be "user-specified" accelerators.

2. No accelerator may clash with a previously defined accelerator, including any legal (alphanumeric) user-specified accelerator anywhere in the collection

3. Prefer alphanumerics at the start of the string.

4. Otherwise, prefer alphanumerics at the start of a word.

5. Otherwise, choose any alphanumeric character not already taken. If no such character is available, give up & skip this string.

A typical use of these functions would be to automatically assign accelerators to a dynamically populated popup menu. For example, the core code was written to automatically set accelerators for the "Load View Profile" popup menu for Konqueror. We quickly realized that it would be useful to make this facility more generally available, so I abstracted it out into a set of templates.

TODO:

+ Add sugar functions for more collections.

+ Add more Deref classes so that we can access a wider variety of collections.

## Function Documentation

bool isLegalAccelerator | ( | const QString & | str,
|  | uint | index
| ) | `[inline]`

  | Helper to determine if the given offset in the string could be a legal alphanumeric accelerator. Parameters:
  str | base string
  index | offset to check
Definition at line 109 of file kaccelgen.h. References QString::length(). Referenced by generate(), and loadPredefined().

template<class Iter, class Deref>
void loadPredefined | ( | Iter | begin,
|  | Iter | end,
|  | QMap< QChar, bool > & | keys
| ) | `[inline]`

  | Loads all legal predefined accelerators in the (implicitly specified) collection into the given QMap. Parameters:
  begin | start iterator
  end | (last+1) iterator
  keys | map to store output
Definition at line 125 of file kaccelgen.h. References KStdAccel::end(), QString::find(), QMap::insert(), and isLegalAccelerator().

template<class Iter, class Iter_Deref>
void generate | ( | Iter | begin,
|  | Iter | end,
|  | QStringList & | target
| ) |

  | Main, maximally flexible template function that assigns accelerators to the elements of a collection of QStrings. Clients will seldom use this directly, as it's usually easier to use one of the wrapper functions that simply takes a collection (see below). The Deref template parameter is a class containing a static dereferencing function, modeled after the comparison class C in Stroustrup 13.4. Parameters:
  begin | (you know)
  end | (you know)
  target | collection to store generated strings
Definition at line 162 of file kaccelgen.h. References QMap::contains(), KStdAccel::end(), QString::find(), QString::insert(), QMap::insert(), isLegalAccelerator(), and QString::length().

template<class Iter>
void generateFromKeys | ( | Iter | begin,
|  | Iter | end,
|  | QStringList & | target
| ) | `[inline]`

  | Another convenience function; looks up the key instead of dereferencing directly for the given iterator. Parameters:
  begin |
  end |
  target |
Definition at line 227 of file kaccelgen.h. References KStdAccel::end(). Referenced by generateFromKeys().

void generate | ( | const QStringList & | source,
|  | QStringList & | target
| ) | `[inline]`

  | Convenience function; generates accelerators for all the items in a QStringList. Parameters:
  source | Strings for which to generate accelerators
  target | Output for accelerator-added strings
Definition at line 240 of file kaccelgen.h.

template<class Key>
void generateFromValues | ( | const QMap< Key, QString > & | source,
|  | QStringList & | target
| ) | `[inline]`

  | Convenience function; generates accelerators for all the values in a QMap<T,QString>. Parameters:
  source | Map with input strings as VALUES.
  target | Output for accelerator-added strings
Definition at line 253 of file kaccelgen.h. References QMap::begin(), and QMap::end().

template<class Data>
void generateFromKeys | ( | const QMap< QString, Data > & | source,
|  | QStringList & | target
| ) | `[inline]`

  | Convenience function; generates an accelerator mapping from all the keys in a QMap<QString,T>. Parameters:
  source | Map with input strings as KEYS.
  target | Output for accelerator-added strings
Definition at line 266 of file kaccelgen.h. References QMap::begin(), QMap::end(), and generateFromKeys().

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:05:29 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001